<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_TrainInfo StructType
 * @subpackage Structs
 */
class JP_TrainInfo extends AbstractStructBase
{
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The StationInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_StationInfo
     */
    public $StationInfo;
    /**
     * Constructor method for JP_TrainInfo
     * @uses JP_TrainInfo::setName()
     * @uses JP_TrainInfo::setStationInfo()
     * @param string $name
     * @param \StructType\JP_StationInfo $stationInfo
     */
    public function __construct($name = null, \StructType\JP_StationInfo $stationInfo = null)
    {
        $this
            ->setName($name)
            ->setStationInfo($stationInfo);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\JP_TrainInfo
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get StationInfo value
     * @return \StructType\JP_StationInfo|null
     */
    public function getStationInfo()
    {
        return $this->StationInfo;
    }
    /**
     * Set StationInfo value
     * @param \StructType\JP_StationInfo $stationInfo
     * @return \StructType\JP_TrainInfo
     */
    public function setStationInfo(\StructType\JP_StationInfo $stationInfo = null)
    {
        $this->StationInfo = $stationInfo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\JP_TrainInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
